<?php
// DEveloper by Joomlok.com 
// Mail Support@joomlok.ru


chdir ('../../');
require_once('api/Simpla.php');

if (isset($_REQUEST["intid"]) && isset($_REQUEST["sign"])) 
{
	// загрузка заказа
	$order_id = $params['account'];
    $simpla = new Simpla();
    $order = $simpla->orders->get_order(intval($_REQUEST["merchant_id"])); 
	if(!empty($order))
	{
		$method = $simpla->payment->get_payment_method(intval($order->payment_method_id));
		if(!empty($method))
		{
			$err = false;
			$message = '';
			$settings = unserialize($method->settings);

			$sign_hash = md5( implode(":", array(
				$settings['public_key'],
				$_REQUEST['amount'],
                $settings['secret_key'],
                $_REQUEST['merchant_id'],
			)));
			
			$valid_ip = true;
			$sIP = str_replace(' ', '', $settings['enotio_ip_list']);
            if ( ! empty( $sIP ) ) {

                $ip_filter_arr = explode(',', $sIP);
                $this_ip  = (isset($_SERVER['HTTP_X_REAL_IP'])) ? $_SERVER['HTTP_X_REAL_IP'] : $_SERVER['REMOTE_ADDR'];

                foreach ( $ip_filter_arr as $key => $value ) {
                    $ip_filter_arr[ $key ] = ip2long( $value );
                }

                if ( ! in_array( ip2long($this_ip), $ip_filter_arr)) {
                    $valid_ip = false;
                }
            }
			if (!$valid_ip)
			{
			
				$message .= " - ip-адрес сервера не является доверенным\n" .
				"   доверенные ip: " . $sIP . "\n" .
				"   ip текущего сервера: " . $_SERVER['REMOTE_ADDR'] . "\n";
				$err = true;
			}
			if (!$err)
			{

				if ($_REQUEST['amount'] != $order->total_price)
				{
					$message .= " - неправильная сумма\n";
					$err = true;
				}

				if (!$err)
				{
					if ($_REQUEST['sign'] == $sign_hash) { 

                        if (!$order->paid) { 
                        $simpla->orders->update_order(intval($order->id), array('paid'=>1));
                        $simpla->orders->close(intval($order->id));
                        $simpla->notify->email_order_user(intval($order->id));
                        $simpla->notify->email_order_admin(intval($order->id));

                        
                        }

                    }
                    else {

                        $message .= " - не совпадают цифровые подписи\n";
                        $err = true;
                    }
				}
			}
			
			if ($err)
			{
				$to = $settings['enotio_email'];

				if (!empty($to))
				{
					$message = "Не удалось провести платёж через систему enotio по следующим причинам:\n\n" . $message . "\n" . $log_text;
					$headers = "From: no-reply@" . $_SERVER['HTTP_HOST'] . "\r\n" . 
					"Content-type: text/plain; charset=utf-8 \r\n";
					mail($to, 'Ошибка оплаты', $message, $headers);
				}
				
				exit($order_id . ' | error | ' . $message);
			}
			else
			{
				exit('YES');
			}
		}
	}
}